
void fadeoff_update (void)

{

  current_millis = millis();

  byte red[12] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
  byte green[12] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
  byte blue[12] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
  byte color_component;
  byte absolute_brightness;

  for (byte note_number = 0; note_number < 128; note_number++)
  {
    if (current_brightness_index[note_number])
    {
      if (noteon[note_number])
      {
        if (fadeup)
        {
          if (current_millis > start_millis[note_number] + fadeup_time)
          {
            if (note_on_sustain && (current_millis > start_millis[note_number] + fadeup_time + noteon_sustain_at))
            { }  // do nothing for sustain
            else
            {
              current_brightness_index[note_number] = fadeoff_map(current_millis, start_millis[note_number] + fadeup_time, start_brightness_index[note_number], noteon_fade_bitshift);
            }
          }
          else
          {
            byte tempvalue = (start_brightness_index[note_number] * (current_millis - start_millis[note_number])) >> fadeup_BS;  // linear fade up
            if (tempvalue >= current_brightness_index[note_number])
            current_brightness_index[note_number] = tempvalue;
            if (!current_brightness_index[note_number])
            {current_brightness_index[note_number] = 1;}  // Ensures that light turns on.  Avoid zero value during fade up.
          }
        }
        else
        {
          current_brightness_index[note_number] = fadeoff_map(current_millis, start_millis[note_number], start_brightness_index[note_number], noteon_fade_bitshift);
        }
      }

      else if (fadeoff_noteoff)
      {
        current_brightness_index[note_number] = fadeoff_map(current_millis, start_millis[note_number], start_brightness_index[note_number], noteoff_fade_bitshift);
      }

      if (DMX_fixtures_curve)
      {
        absolute_brightness = current_brightness_index[note_number];
      }
      else
      {
        absolute_brightness = curve[current_brightness_index[note_number]];
      }

      color_component = HB2red (hue[note_number], absolute_brightness);
      if (color_component > red[note_light_map[note_number]])
      {
        red[note_light_map[note_number]] = color_component;
      }

      color_component = HB2green (hue[note_number], absolute_brightness);
      if (color_component > green[note_light_map[note_number]])
      {
        green[note_light_map[note_number]] = color_component;
      }

      color_component = HB2blue (hue[note_number], absolute_brightness);
      if (color_component > blue[note_light_map[note_number]])
      {
        blue[note_light_map[note_number]] = color_component;
      }
    }
  }

  DMXset(1, red[0]);
  DMXset(2, green[0]);
  DMXset(3, blue[0]);
  DMXset(4, red[1]);
  DMXset(5, green[1]);
  DMXset(6, blue[1]);
  DMXset(7, red[2]);
  DMXset(8, green[2]);
  DMXset(9, blue[2]);
  DMXset(10, red[3]);
  DMXset(11, green[3]);
  DMXset(12, blue[3]);
  DMXset(13, red[4]);
  DMXset(14, green[4]);
  DMXset(15, blue[4]);
  DMXset(16, red[5]);
  DMXset(17, green[5]);
  DMXset(18, blue[5]);
  DMXset(19, red[6]);
  DMXset(20, green[6]);
  DMXset(21, blue[6]);
  DMXset(22, red[7]);
  DMXset(23, green[7]);
  DMXset(24, blue[7]);
  DMXset(25, red[8]);
  DMXset(26, green[8]);
  DMXset(27, blue[8]);
  DMXset(28, red[9]);
  DMXset(29, green[9]);
  DMXset(30, blue[9]);
  DMXset(31, red[10]);
  DMXset(32, green[10]);
  DMXset(33, blue[10]);
  DMXset(34, red[11]);
  DMXset(35, green[11]);
  DMXset(36, blue[11]);
  DMXupdate();

}


